#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import urlparse
import urlgrabber.grabber as grabber

class Download(object):
    """ borrowed from anaconda's urlinstall method
    """
    def __init__(self, url, dst):
        self.url = url
        self.dst = dst

        (scheme, netloc, path, query, fragid) = urlparse.urlsplit(self.url)
        self.file = os.path.basename(path)
        self.output = os.path.join(self.dst, self.file)

    def status(self, cur_percent):
        sys.stdout.write("Downloading %3d%%" % (cur_percent) + "\r")
        sys.stdout.flush()

    def get(self):
        try:
            url = grabber.urlopen(self.url)
        except grabber.URLGrabError, e:
            raise IOError (e.errno, e.strerror)

        # check size
        try:
            filesize = int(url.info()["Content-Length"])
            if filesize == 0:
                filesize = None
        except:
            filesize = None

        #write output
        f = open(self.output, "w+")

        buf = url.read(65535)
        tot = len(buf)
        while len(buf) > 0:
            if filesize is not None:
                self.status((100*tot)/filesize)
            else:
                self.status(tot/1024)
            f.write(buf)
            buf = url.read(65535)
            tot += len(buf)

        f.close()
        url.close()
        return self.output
